diff --git a/kernel/device.c b/kernel/device.c
index deb9636b0ecf8f47e832a0b07e9e049ba19bdf16..2c55e2c39da988231bd643372d961dea77b0cddb 100644
--- a/kernel/device.c
+++ b/kernel/device.c
@@ -1,10 +1,12 @@
 // SPDX-License-Identifier: GPL-2.0
 /*
  * Copyright (C) 2015-2019 Jason A. Donenfeld <Jason@zx2c4.com>. All Rights Reserved.
+ * TCP Support Copyright (c) 2024-2026 Jeff Nathan and Dragos Ruiu. All Rights Reserved.
  */
 
 #include "queueing.h"
 #include "socket.h"
+#include "wg_tcp.h"
 #include "timers.h"
 #include "device.h"
 #include "ratelimiter.h"
@@ -19,14 +21,27 @@
 #include <linux/if_arp.h>
 #include <linux/icmp.h>
 #include <linux/suspend.h>
+#include <linux/spinlock.h>
+#include <linux/wireguard.h>
 #include <net/dst_metadata.h>
 #include <net/gso.h>
 #include <net/icmp.h>
 #include <net/rtnetlink.h>
 #include <net/ip_tunnels.h>
 #include <net/addrconf.h>
+#include <net/fib_notifier.h>
+#include <net/netns/generic.h>
+#include "wg_tcp_debug.h"
 
 static LIST_HEAD(device_list);
+static unsigned int wg_net_id;
+
+struct wg_net {
+	struct net *net;
+	struct notifier_block fib_notifier;
+	struct delayed_work fib_dispatch_work;
+	bool fib_registered;
+};
 
 static int wg_open(struct net_device *dev)
 {
@@ -34,7 +49,12 @@ static int wg_open(struct net_device *dev)
 	struct inet6_dev *dev_v6 = __in6_dev_get(dev);
 	struct wg_device *wg = netdev_priv(dev);
 	struct wg_peer *peer;
-	int ret;
+	u16 requested_port = wg->incoming_port;
+	int ret = 0;
+
+	wg_dbg("Entering wg_open: dev=%px\n", dev);
+	WRITE_ONCE(wg->tcp_cleanup_scheduled,
+		   wg->transport == WG_TRANSPORT_TCP);
 
 	if (dev_v4) {
 		/* At some point we might put this check near the ip_rt_send_
@@ -47,17 +67,68 @@ static int wg_open(struct net_device *dev)
 	if (dev_v6)
 		dev_v6->cnf.addr_gen_mode = IN6_ADDR_GEN_MODE_NONE;
 
-	mutex_lock(&wg->device_update_lock);
+
+	wg->listener_active = false;
+	/* Bind UDP first so port zero retains WireGuard's random-port semantics.
+	 * TCP then uses the concrete port selected by the companion UDP socket.
+	 */
 	ret = wg_socket_init(wg, wg->incoming_port);
-	if (ret < 0)
-		goto out;
+	if (ret < 0) {
+		WRITE_ONCE(wg->tcp_cleanup_scheduled, false);
+		return ret;
+	}
+	if (wg->transport == WG_TRANSPORT_TCP) {
+		if (!wg->tcp_auth_wq) {
+			wg->tcp_auth_wq = alloc_workqueue("wg-tcp-auth-%s",
+						  WQ_UNBOUND | WQ_MEM_RECLAIM,
+						  0, dev->name);
+			if (!wg->tcp_auth_wq) {
+				ret = -ENOMEM;
+				goto err_tcp_open;
+			}
+		}
+		ret = wg_tcp_listener_socket_init(wg, wg->incoming_port);
+		if (ret < 0)
+			goto err_tcp_open;
+	}
+	mutex_lock(&wg->device_update_lock);
 	list_for_each_entry(peer, &wg->peer_list, peer_list) {
+		bool queue_tcp_retry = false;
+		bool tcp_quarantined = false;
+
+		if (wg->transport == WG_TRANSPORT_TCP) {
+			spin_lock_bh(&peer->tcp_lock);
+			tcp_quarantined = peer->tcp_teardown_quarantined;
+			if (!tcp_quarantined)
+				peer->tcp_stopping = false;
+			if (!tcp_quarantined && peer->peer_endpoint_set &&
+			    !peer->tcp_retry_scheduled &&
+			    !peer->tcp_outbound_remove_scheduled) {
+				peer->tcp_retry_scheduled = true;
+				queue_tcp_retry = true;
+			}
+			if (queue_tcp_retry)
+				mod_delayed_work(system_wq, &peer->tcp_retry_work, 0);
+			spin_unlock_bh(&peer->tcp_lock);
+		}
+		if (tcp_quarantined)
+			continue;
 		wg_packet_send_staged_packets(peer);
 		if (peer->persistent_keepalive_interval)
 			wg_packet_send_keepalive(peer);
 	}
-out:
 	mutex_unlock(&wg->device_update_lock);
+	wg_dbg("Exiting wg_open: dev=%px, ret=%d\n", dev, ret);
+	return ret;
+
+err_tcp_open:
+	WRITE_ONCE(wg->tcp_cleanup_scheduled, false);
+	wg_tcp_listener_socket_release(wg);
+	cancel_delayed_work_sync(&wg->tcp_cleanup_work);
+	wg_destruct_tcp_connection_list(wg);
+	cancel_delayed_work_sync(&wg->tcp_cleanup_work);
+	wg_socket_reinit(wg, NULL, NULL);
+	wg->incoming_port = requested_port;
 	return ret;
 }
 
@@ -66,16 +137,22 @@ static int wg_pm_notification(struct notifier_block *nb, unsigned long action, v
 	struct wg_device *wg;
 	struct wg_peer *peer;
 
+	wg_dbg("Entering wg_pm_notification: nb=%px, action=%lu, data=%px\n", nb, action, data);
+
 	/* If the machine is constantly suspending and resuming, as part of
 	 * its normal operation rather than as a somewhat rare event, then we
 	 * don't actually want to clear keys.
 	 */
 	if (IS_ENABLED(CONFIG_PM_AUTOSLEEP) ||
-	    IS_ENABLED(CONFIG_PM_USERSPACE_AUTOSLEEP))
+	    IS_ENABLED(CONFIG_PM_USERSPACE_AUTOSLEEP)) {
+		wg_dbg("Exiting wg_pm_notification (no action): nb=%px, action=%lu, data=%px\n", nb, action, data);
 		return 0;
+	}
 
-	if (action != PM_HIBERNATION_PREPARE && action != PM_SUSPEND_PREPARE)
+	if (action != PM_HIBERNATION_PREPARE && action != PM_SUSPEND_PREPARE) {
+		wg_dbg("Exiting wg_pm_notification (no action): nb=%px, action=%lu, data=%px\n", nb, action, data);
 		return 0;
+	}
 
 	rtnl_lock();
 	list_for_each_entry(wg, &device_list, device_list) {
@@ -89,6 +166,7 @@ static int wg_pm_notification(struct notifier_block *nb, unsigned long action, v
 	}
 	rtnl_unlock();
 	rcu_barrier();
+	wg_dbg("Exiting wg_pm_notification: nb=%px, action=%lu, data=%px\n", nb, action, data);
 	return 0;
 }
 
@@ -99,6 +177,8 @@ static int wg_vm_notification(struct notifier_block *nb, unsigned long action, v
 	struct wg_device *wg;
 	struct wg_peer *peer;
 
+	wg_dbg("Entering wg_vm_notification: nb=%px, action=%lu, data=%px\n", nb, action, data);
+
 	rtnl_lock();
 	list_for_each_entry(wg, &device_list, device_list) {
 		mutex_lock(&wg->device_update_lock);
@@ -107,18 +187,175 @@ static int wg_vm_notification(struct notifier_block *nb, unsigned long action, v
 		mutex_unlock(&wg->device_update_lock);
 	}
 	rtnl_unlock();
+	wg_dbg("Exiting wg_vm_notification: nb=%px, action=%lu, data=%px\n", nb, action, data);
 	return 0;
 }
 
 static struct notifier_block vm_notifier = { .notifier_call = wg_vm_notification };
 
+static void wg_tcp_route_change_worker(struct work_struct *work)
+{
+	struct wg_device *wg = container_of(work, struct wg_device,
+					    tcp_route_work.work);
+	struct wg_peer *peer;
+
+	mutex_lock(&wg->device_update_lock);
+	if (wg->transport == WG_TRANSPORT_TCP &&
+	    READ_ONCE(wg->tcp_cleanup_scheduled) && netif_running(wg->dev) &&
+	    rcu_access_pointer(wg->creating_net)) {
+		list_for_each_entry(peer, &wg->peer_list, peer_list) {
+			wg_socket_clear_peer_endpoint_src(peer);
+			wg_tcp_peer_request_reconnect(peer);
+		}
+	}
+	mutex_unlock(&wg->device_update_lock);
+}
+
+static void wg_tcp_fib_dispatch_worker(struct work_struct *work)
+{
+	struct wg_net *wn = container_of(work, struct wg_net,
+					 fib_dispatch_work.work);
+	struct wg_device *wg;
+
+	rtnl_lock();
+	list_for_each_entry(wg, &device_list, device_list) {
+		if (rcu_access_pointer(wg->creating_net) != wn->net ||
+		    wg->transport != WG_TRANSPORT_TCP ||
+		    !READ_ONCE(wg->tcp_cleanup_scheduled) ||
+		    !netif_running(wg->dev))
+			continue;
+		mod_delayed_work(system_wq, &wg->tcp_route_work,
+				 msecs_to_jiffies(100));
+	}
+	rtnl_unlock();
+}
+
+static int wg_tcp_fib_notification(struct notifier_block *nb,
+				   unsigned long action, void *data)
+{
+	struct wg_net *wn = container_of(nb, struct wg_net, fib_notifier);
+	const struct fib_notifier_info *info = data;
+
+	if (!READ_ONCE(wn->fib_registered) || !info ||
+	    (info->family != AF_INET && info->family != AF_INET6))
+		return NOTIFY_DONE;
+	switch (action) {
+	case FIB_EVENT_ENTRY_REPLACE:
+	case FIB_EVENT_ENTRY_APPEND:
+	case FIB_EVENT_ENTRY_ADD:
+	case FIB_EVENT_ENTRY_DEL:
+	case FIB_EVENT_RULE_ADD:
+	case FIB_EVENT_RULE_DEL:
+	case FIB_EVENT_NH_ADD:
+	case FIB_EVENT_NH_DEL:
+		mod_delayed_work(system_wq, &wn->fib_dispatch_work, 0);
+		break;
+	default:
+		break;
+	}
+	return NOTIFY_DONE;
+}
+
+/* Address and link notifiers run under RTNL, which also protects device_list.
+ * Queueing keeps socket shutdown and reconnect work out of notifier context and
+ * coalesces the event bursts emitted by one administrative change.
+ */
+static void wg_tcp_schedule_route_change(struct net_device *changed_dev)
+{
+	struct wg_device *wg;
+
+	if (!changed_dev)
+		return;
+	list_for_each_entry(wg, &device_list, device_list) {
+		if (wg->dev == changed_dev ||
+		    rcu_access_pointer(wg->creating_net) != dev_net(changed_dev) ||
+		    wg->transport != WG_TRANSPORT_TCP)
+			continue;
+		mod_delayed_work(system_wq, &wg->tcp_route_work,
+				 msecs_to_jiffies(100));
+	}
+}
+
+static int wg_netdevice_notification(struct notifier_block *nb,
+				     unsigned long action, void *data)
+{
+	struct net_device *changed_dev = netdev_notifier_info_to_dev(data);
+
+	switch (action) {
+	case NETDEV_UP:
+	case NETDEV_DOWN:
+	case NETDEV_CHANGE:
+	case NETDEV_CHANGEADDR:
+	case NETDEV_UNREGISTER:
+		wg_tcp_schedule_route_change(changed_dev);
+		break;
+	default:
+		break;
+	}
+	return NOTIFY_DONE;
+}
+
+static struct notifier_block netdevice_notifier = {
+	.notifier_call = wg_netdevice_notification
+};
+
+static int wg_inetaddr_notification(struct notifier_block *nb,
+				    unsigned long action, void *data)
+{
+	const struct in_ifaddr *ifa = data;
+
+	if (ifa && ifa->ifa_dev)
+		wg_tcp_schedule_route_change(ifa->ifa_dev->dev);
+	return NOTIFY_DONE;
+}
+
+static struct notifier_block inetaddr_notifier = {
+	.notifier_call = wg_inetaddr_notification
+};
+
+#if IS_ENABLED(CONFIG_IPV6)
+static int wg_inet6addr_notification(struct notifier_block *nb,
+				     unsigned long action, void *data)
+{
+	const struct inet6_ifaddr *ifa = data;
+
+	if (ifa && ifa->idev)
+		wg_tcp_schedule_route_change(ifa->idev->dev);
+	return NOTIFY_DONE;
+}
+
+static struct notifier_block inet6addr_notifier = {
+	.notifier_call = wg_inet6addr_notification
+};
+#endif
+
 static int wg_stop(struct net_device *dev)
 {
 	struct wg_device *wg = netdev_priv(dev);
 	struct wg_peer *peer;
 	struct sk_buff *skb;
 
+	wg_dbg("Entering wg_stop: dev=%px\n", dev);
+	WRITE_ONCE(wg->tcp_cleanup_scheduled, false);
+	cancel_delayed_work_sync(&wg->tcp_route_work);
 	mutex_lock(&wg->device_update_lock);
+	if (wg->transport == WG_TRANSPORT_TCP) {
+		/* Quiesce every connect/removal owner before releasing the shared
+		 * listeners. Otherwise an in-flight connect can republish listener or
+		 * peer socket state after the device teardown pass.
+		 */
+		list_for_each_entry(peer, &wg->peer_list, peer_list)
+			wg_tcp_peer_stop(peer);
+		wg_tcp_listener_socket_release(wg);
+	}
+	cancel_delayed_work_sync(&wg->tcp_cleanup_work);
+	wg_destruct_tcp_connection_list(wg);
+	/* Destruction drains temp-peer callbacks that may have passed their
+	 * cleanup flag check before shutdown. Catch any device work queued by
+	 * such a callback after the first cancellation pass.
+	 */
+	cancel_delayed_work_sync(&wg->tcp_cleanup_work);
+
 	list_for_each_entry(peer, &wg->peer_list, peer_list) {
 		wg_packet_purge_staged_packets(peer);
 		wg_timers_stop(peer);
@@ -129,8 +366,12 @@ static int wg_stop(struct net_device *dev)
 	mutex_unlock(&wg->device_update_lock);
 	while ((skb = ptr_ring_consume(&wg->handshake_queue.ring)) != NULL)
 		kfree_skb(skb);
+
 	atomic_set(&wg->handshake_queue_len, 0);
+
 	wg_socket_reinit(wg, NULL, NULL);
+
+	wg_dbg("Exiting wg_stop: dev=%px\n", dev);
 	return 0;
 }
 
@@ -144,6 +385,8 @@ static netdev_tx_t wg_xmit(struct sk_buff *skb, struct net_device *dev)
 	u32 mtu;
 	int ret;
 
+	wg_dbg("Entering wg_xmit: skb=%px, dev=%px\n", skb, dev);
+
 	if (unlikely(!wg_check_packet_protocol(skb))) {
 		ret = -EPROTONOSUPPORT;
 		net_dbg_ratelimited("%s: Invalid IP packet\n", dev->name);
@@ -218,6 +461,7 @@ static netdev_tx_t wg_xmit(struct sk_buff *skb, struct net_device *dev)
 	wg_packet_send_staged_packets(peer);
 
 	wg_peer_put(peer);
+	wg_dbg("Exiting wg_xmit: skb=%px, dev=%px\n", skb, dev);
 	return NETDEV_TX_OK;
 
 err_peer:
@@ -230,6 +474,7 @@ err_icmp:
 err:
 	DEV_STATS_INC(dev, tx_errors);
 	kfree_skb(skb);
+	wg_dbg("Exiting wg_xmit with error: skb=%px, dev=%px, ret=%d\n", skb, dev, ret);
 	return ret;
 }
 
@@ -244,10 +489,28 @@ static void wg_destruct(struct net_device *dev)
 {
 	struct wg_device *wg = netdev_priv(dev);
 
+	wg_dbg("Entering wg_destruct: dev=%px\n", dev);
+
 	rtnl_lock();
 	list_del(&wg->device_list);
 	rtnl_unlock();
+	cancel_delayed_work_sync(&wg->tcp_route_work);
 	mutex_lock(&wg->device_update_lock);
+	WRITE_ONCE(wg->tcp_cleanup_scheduled, false);
+	if (wg->transport == WG_TRANSPORT_TCP) {
+		struct wg_peer *peer;
+
+		list_for_each_entry(peer, &wg->peer_list, peer_list)
+			wg_tcp_peer_stop(peer);
+		wg_tcp_listener_socket_release(wg);
+	}
+	cancel_delayed_work_sync(&wg->tcp_cleanup_work);
+	wg_destruct_tcp_connection_list(wg);
+	cancel_delayed_work_sync(&wg->tcp_cleanup_work);
+	if (wg->tcp_auth_wq) {
+		destroy_workqueue(wg->tcp_auth_wq);
+		wg->tcp_auth_wq = NULL;
+	}
 	rcu_assign_pointer(wg->creating_net, NULL);
 	wg->incoming_port = 0;
 	wg_socket_reinit(wg, NULL, NULL);
@@ -269,6 +532,8 @@ static void wg_destruct(struct net_device *dev)
 
 	pr_debug("%s: Interface destroyed\n", dev->name);
 	free_netdev(dev);
+
+	wg_dbg("Exiting wg_destruct: dev=%px\n", dev);
 }
 
 static const struct device_type device_type = { .name = KBUILD_MODNAME };
@@ -280,13 +545,16 @@ static void wg_setup(struct net_device *dev)
 				    NETIF_F_SG | NETIF_F_GSO |
 				    NETIF_F_GSO_SOFTWARE | NETIF_F_HIGHDMA };
 	const int overhead = MESSAGE_MINIMUM_LENGTH + sizeof(struct udphdr) +
-			     max(sizeof(struct ipv6hdr), sizeof(struct iphdr));
+			     max(sizeof(struct ipv6hdr), sizeof(struct iphdr)) +
+			     (wg->transport == WG_TRANSPORT_TCP ? WG_TCP_ENCAP_HDR_LEN : 0);
+
+	wg_dbg("Entering wg_setup: dev=%px\n", dev);
 
 	dev->netdev_ops = &netdev_ops;
 	dev->header_ops = &ip_tunnel_header_ops;
 	dev->hard_header_len = 0;
 	dev->addr_len = 0;
-	dev->needed_headroom = DATA_PACKET_HEAD_ROOM;
+	dev->needed_headroom = DATA_PACKET_HEAD_ROOM + (wg->transport ? WG_TCP_ENCAP_HDR_LEN : 0);
 	dev->needed_tailroom = noise_encrypted_len(MESSAGE_PADDING_MULTIPLE);
 	dev->type = ARPHRD_NONE;
 	dev->flags = IFF_POINTOPOINT | IFF_NOARP;
@@ -305,6 +573,8 @@ static void wg_setup(struct net_device *dev)
 
 	memset(wg, 0, sizeof(*wg));
 	wg->dev = dev;
+
+	wg_dbg("Exiting wg_setup: dev=%px\n", dev);
 }
 
 static int wg_newlink(struct net *src_net, struct net_device *dev,
@@ -314,6 +584,8 @@ static int wg_newlink(struct net *src_net, struct net_device *dev,
 	struct wg_device *wg = netdev_priv(dev);
 	int ret = -ENOMEM;
 
+	wg_dbg("Entering wg_newlink: src_net=%px, dev=%px, tb=%px, data=%px, extack=%px\n", src_net, dev, tb, data, extack);
+
 	rcu_assign_pointer(wg->creating_net, src_net);
 	init_rwsem(&wg->static_identity.lock);
 	mutex_init(&wg->socket_update_lock);
@@ -322,6 +594,13 @@ static int wg_newlink(struct net *src_net, struct net_device *dev,
 	wg_cookie_checker_init(&wg->cookie_checker, wg);
 	INIT_LIST_HEAD(&wg->peer_list);
 	wg->device_update_gen = 1;
+	/* Initialize the tcp_cleanup_scheduled flag and spinlock */
+	wg->tcp_cleanup_scheduled = false;
+	spin_lock_init(&wg->tcp_cleanup_lock);
+
+	/* Initialize the work for tcp_cleanup_worker */
+	INIT_DELAYED_WORK(&wg->tcp_cleanup_work, wg_tcp_cleanup_worker);
+	INIT_DELAYED_WORK(&wg->tcp_route_work, wg_tcp_route_change_worker);
 
 	wg->peer_hashtable = wg_pubkey_hashtable_alloc();
 	if (!wg->peer_hashtable)
@@ -375,14 +654,22 @@ static int wg_newlink(struct net *src_net, struct net_device *dev,
 
 	list_add(&wg->device_list, &device_list);
 
+	INIT_LIST_HEAD(&wg->tcp_connection_list);
+	spin_lock_init(&wg->tcp_connection_list_lock);
+	spin_lock_init(&wg->tcp_accept_lock);
+	atomic64_set(&wg->tcp_connection_sequence, 0);
+	wg->tcp_socket4_ready = false;
+	wg->tcp_socket6_ready = false;
+
 	/* We wait until the end to assign priv_destructor, so that
 	 * register_netdevice doesn't call it for us if it fails.
 	 */
 	dev->priv_destructor = wg_destruct;
 
 	pr_debug("%s: Interface created\n", dev->name);
-	return ret;
 
+	wg_dbg("Exiting wg_newlink: src_net=%px, dev=%px, ret=%d\n", src_net, dev, ret);
+	return ret;
 err_uninit_ratelimiter:
 	wg_ratelimiter_uninit();
 err_free_handshake_queue:
@@ -403,6 +690,7 @@ err_free_index_hashtable:
 	kvfree(wg->index_hashtable);
 err_free_peer_hashtable:
 	kvfree(wg->peer_hashtable);
+	wg_dbg("Exiting wg_newlink with error: src_net=%px, dev=%px, ret=%d\n", src_net, dev, ret);
 	return ret;
 }
 
@@ -413,17 +701,57 @@ static struct rtnl_link_ops link_ops __read_mostly = {
 	.newlink		= wg_newlink,
 };
 
+static int wg_netns_init(struct net *net)
+{
+	struct wg_net *wn = net_generic(net, wg_net_id);
+	int ret;
+
+	wn->net = net;
+	wn->fib_notifier.notifier_call = wg_tcp_fib_notification;
+	INIT_DELAYED_WORK(&wn->fib_dispatch_work,
+			  wg_tcp_fib_dispatch_worker);
+	ret = register_fib_notifier(net, &wn->fib_notifier, NULL, NULL);
+	if (ret) {
+		pr_warn("wireguard: TCP route notifications unavailable in netns %u: %d\n",
+			net->ns.inum, ret);
+		return 0;
+	}
+	WRITE_ONCE(wn->fib_registered, true);
+	return 0;
+}
+
 static void wg_netns_pre_exit(struct net *net)
 {
+	struct wg_net *wn = net_generic(net, wg_net_id);
 	struct wg_device *wg;
 	struct wg_peer *peer;
 
+	wg_dbg("Entering wg_netns_pre_exit: net=%px\n", net);
+	if (READ_ONCE(wn->fib_registered)) {
+		WRITE_ONCE(wn->fib_registered, false);
+		unregister_fib_notifier(net, &wn->fib_notifier);
+	}
+	cancel_delayed_work_sync(&wn->fib_dispatch_work);
+
 	rtnl_lock();
 	list_for_each_entry(wg, &device_list, device_list) {
 		if (rcu_access_pointer(wg->creating_net) == net) {
 			pr_debug("%s: Creating namespace exiting\n", wg->dev->name);
 			netif_carrier_off(wg->dev);
+			cancel_delayed_work_sync(&wg->tcp_route_work);
 			mutex_lock(&wg->device_update_lock);
+			if (wg->transport == WG_TRANSPORT_TCP) {
+				/* Stop every user of sockets created in this namespace
+				 * before publishing that the namespace is gone.
+				 */
+				WRITE_ONCE(wg->tcp_cleanup_scheduled, false);
+				list_for_each_entry(peer, &wg->peer_list, peer_list)
+					wg_tcp_peer_stop(peer);
+				wg_tcp_listener_socket_release(wg);
+				cancel_delayed_work_sync(&wg->tcp_cleanup_work);
+				wg_destruct_tcp_connection_list(wg);
+				cancel_delayed_work_sync(&wg->tcp_cleanup_work);
+			}
 			rcu_assign_pointer(wg->creating_net, NULL);
 			wg_socket_reinit(wg, NULL, NULL);
 			list_for_each_entry(peer, &wg->peer_list, peer_list)
@@ -432,19 +760,26 @@ static void wg_netns_pre_exit(struct net *net)
 		}
 	}
 	rtnl_unlock();
+
+	wg_dbg("Exiting wg_netns_pre_exit: net=%px\n", net);
 }
 
 static struct pernet_operations pernet_ops = {
-	.pre_exit = wg_netns_pre_exit
+	.init = wg_netns_init,
+	.pre_exit = wg_netns_pre_exit,
+	.id = &wg_net_id,
+	.size = sizeof(struct wg_net),
 };
 
 int __init wg_device_init(void)
 {
 	int ret;
 
+	wg_dbg("Entering wg_device_init\n");
+
 	ret = register_pm_notifier(&pm_notifier);
 	if (ret)
-		return ret;
+		goto error;
 
 	ret = register_random_vmfork_notifier(&vm_notifier);
 	if (ret)
@@ -454,26 +789,60 @@ int __init wg_device_init(void)
 	if (ret)
 		goto error_vm;
 
-	ret = rtnl_link_register(&link_ops);
+	ret = register_netdevice_notifier(&netdevice_notifier);
 	if (ret)
 		goto error_pernet;
 
+	ret = register_inetaddr_notifier(&inetaddr_notifier);
+	if (ret)
+		goto error_netdevice;
+
+#if IS_ENABLED(CONFIG_IPV6)
+	ret = register_inet6addr_notifier(&inet6addr_notifier);
+	if (ret)
+		goto error_inetaddr;
+#endif
+
+	ret = rtnl_link_register(&link_ops);
+	if (ret)
+		goto error_inet6addr;
+
+	wg_dbg("Exiting wg_device_init: ret=0\n");
 	return 0;
 
+error_inet6addr:
+#if IS_ENABLED(CONFIG_IPV6)
+	unregister_inet6addr_notifier(&inet6addr_notifier);
+error_inetaddr:
+#endif
+	unregister_inetaddr_notifier(&inetaddr_notifier);
+error_netdevice:
+	unregister_netdevice_notifier(&netdevice_notifier);
 error_pernet:
 	unregister_pernet_device(&pernet_ops);
 error_vm:
 	unregister_random_vmfork_notifier(&vm_notifier);
 error_pm:
 	unregister_pm_notifier(&pm_notifier);
+error:
+	wg_dbg("Exiting wg_device_init with error: ret=%d\n", ret);
 	return ret;
 }
 
 void wg_device_uninit(void)
 {
+	wg_dbg("Entering wg_device_uninit\n");
+
 	rtnl_link_unregister(&link_ops);
+#if IS_ENABLED(CONFIG_IPV6)
+	unregister_inet6addr_notifier(&inet6addr_notifier);
+#endif
+	unregister_inetaddr_notifier(&inetaddr_notifier);
+	unregister_netdevice_notifier(&netdevice_notifier);
 	unregister_pernet_device(&pernet_ops);
 	unregister_random_vmfork_notifier(&vm_notifier);
 	unregister_pm_notifier(&pm_notifier);
 	rcu_barrier();
+
+	wg_dbg("Exiting wg_device_uninit\n");
 }
diff --git a/kernel/device.h b/kernel/device.h
index 43c7cebbf50b08f2a1868f0017d0bee8aee700f8..8abb4df7ae5301565f4c4d499d87684a3600bc2d 100644
--- a/kernel/device.h
+++ b/kernel/device.h
@@ -1,6 +1,7 @@
 /* SPDX-License-Identifier: GPL-2.0 */
 /*
  * Copyright (C) 2015-2019 Jason A. Donenfeld <Jason@zx2c4.com>. All Rights Reserved.
+ * TCP Support Copyright (c) 2024-2026 Jeff Nathan and Dragos Ruiu. All Rights Reserved.
  */
 
 #ifndef _WG_DEVICE_H
@@ -11,12 +12,15 @@
 #include "peerlookup.h"
 #include "cookie.h"
 
+
 #include <linux/types.h>
 #include <linux/netdevice.h>
 #include <linux/workqueue.h>
+#include <linux/ktime.h>
 #include <linux/mutex.h>
 #include <linux/net.h>
 #include <linux/ptr_ring.h>
+#include <linux/spinlock.h>
 
 struct wg_device;
 
@@ -33,27 +37,76 @@ struct crypt_queue {
 
 struct prev_queue {
 	struct sk_buff *head, *tail, *peeked;
-	struct { struct sk_buff *next, *prev; } empty; // Match first 2 members of struct sk_buff.
+	/* Must match the first two members of struct sk_buff. */
+	struct { struct sk_buff *next, *prev; } empty;
 	atomic_t count;
 };
 
+struct endpoint {
+	union {
+		struct sockaddr addr;
+		struct sockaddr_in addr4;
+		struct sockaddr_in6 addr6;
+	};
+	union {
+		struct {
+			struct in_addr src4;
+			/* Essentially the same as addr6->scope_id */
+			int src_if4;
+		};
+		struct in6_addr src6;
+	};
+};
+
+#define WG_TCP_ACCEPT_SOURCE_SLOTS 128
+
+struct wg_tcp_accept_source {
+	union {
+		__be32 addr4;
+		struct in6_addr addr6;
+	} address;
+	unsigned long window_started;
+	unsigned long last_seen;
+	u32 scope_id;
+	u16 accepts;
+	sa_family_t family;
+};
+
 struct wg_device {
 	struct net_device *dev;
 	struct crypt_queue encrypt_queue, decrypt_queue, handshake_queue;
-	struct sock __rcu *sock4, *sock6;
+	struct sock __rcu *sock4, *sock6; /* UDP listening sockets */
+	struct socket __rcu *tcp_listen_socket4, *tcp_listen_socket6; /* TCP listening sockets */
 	struct net __rcu *creating_net;
 	struct noise_static_identity static_identity;
 	struct workqueue_struct *packet_crypt_wq,*handshake_receive_wq, *handshake_send_wq;
+	struct workqueue_struct *tcp_auth_wq;
 	struct cookie_checker cookie_checker;
 	struct pubkey_hashtable *peer_hashtable;
 	struct index_hashtable *index_hashtable;
 	struct allowedips peer_allowedips;
 	struct mutex device_update_lock, socket_update_lock;
-	struct list_head device_list, peer_list;
+	struct endpoint device_endpoint;
+	struct list_head device_list, peer_list, tcp_connection_list;
+	struct task_struct *tcp_listener4_thread, *tcp_listener6_thread;
+	struct delayed_work tcp_cleanup_work;
+	struct delayed_work tcp_route_work;
+        spinlock_t tcp_cleanup_lock; /* Add a spinlock to protect the flag */
+	bool tcp_cleanup_scheduled;
+	bool tcp_socket4_ready;
+	bool tcp_socket6_ready;
+	bool listener_active;
+	spinlock_t tcp_connection_list_lock;
+	unsigned int tcp_pending_connections;
+	unsigned int tcp_tracked_connections;
+	atomic64_t tcp_connection_sequence;
+	spinlock_t tcp_accept_lock;
+	struct wg_tcp_accept_source tcp_accept_sources[WG_TCP_ACCEPT_SOURCE_SLOTS];
 	atomic_t handshake_queue_len;
 	unsigned int num_peers, device_update_gen;
 	u32 fwmark;
 	u16 incoming_port;
+	u8 transport;
 };
 
 int wg_device_init(void);
diff --git a/kernel/main.c b/kernel/main.c
index ee4da9ab8013c3ad2721e0e1d4432b2fe007886b..38b4db7868505c439fc48af9808f8207991d0663 100644
--- a/kernel/main.c
+++ b/kernel/main.c
@@ -9,6 +9,8 @@
 #include "queueing.h"
 #include "ratelimiter.h"
 #include "netlink.h"
+#include "socket.h"
+#include "cookie.h"
 
 #include <uapi/linux/wireguard.h>
 
@@ -17,37 +19,50 @@
 #include <linux/genetlink.h>
 #include <net/rtnetlink.h>
 
+#include "wg_tcp_debug.h"
+
 static int __init wg_mod_init(void)
 {
 	int ret;
 
+	wg_dbg("Entering: wg_mod_init\n");
+
 	ret = wg_allowedips_slab_init();
+	wg_dbg("wg_mod_init: wg_allowedips_slab_init() = %d\n", ret);
 	if (ret < 0)
 		goto err_allowedips;
 
 #ifdef DEBUG
 	ret = -ENOTRECOVERABLE;
 	if (!wg_allowedips_selftest() || !wg_packet_counter_selftest() ||
-	    !wg_ratelimiter_selftest())
+	    !wg_ratelimiter_selftest() || !wg_cookie_policy_selftest()) {
+		wg_dbg("wg_mod_init: Self-test failed\n");
 		goto err_peer;
+	}
 #endif
 	wg_noise_init();
+	wg_dbg("wg_mod_init: wg_noise_init() completed\n");
 
 	ret = wg_peer_init();
+	wg_dbg("wg_mod_init: wg_peer_init() = %d\n", ret);
 	if (ret < 0)
 		goto err_peer;
 
 	ret = wg_device_init();
+	wg_dbg("wg_mod_init: wg_device_init() = %d\n", ret);
 	if (ret < 0)
 		goto err_device;
 
 	ret = wg_genetlink_init();
+	wg_dbg("wg_mod_init: wg_genetlink_init() = %d\n", ret);
 	if (ret < 0)
 		goto err_netlink;
 
-	pr_info("WireGuard " WIREGUARD_VERSION " loaded. See www.wireguard.com for information.\n");
-	pr_info("Copyright (C) 2015-2019 Jason A. Donenfeld <Jason@zx2c4.com>. All Rights Reserved.\n");
+	wg_dbg("WireGuard " WIREGUARD_VERSION " loaded. See www.wireguard.com for information.\n");
+	wg_dbg("Copyright (C) 2015-2019 Jason A. Donenfeld <Jason@zx2c4.com>. All Rights Reserved.\n");
+	wg_dbg("TCP Transport Mode - Copyright (C) 2024 Jeff Nathan and Dragos Ruiu. All Rights Reserved.\n");
 
+	wg_dbg("Exiting: wg_mod_init\n");
 	return 0;
 
 err_netlink:
@@ -57,21 +72,33 @@ err_device:
 err_peer:
 	wg_allowedips_slab_uninit();
 err_allowedips:
+	wg_dbg("Exiting with error: wg_mod_init, ret = %d\n", ret);
 	return ret;
 }
 
 static void __exit wg_mod_exit(void)
 {
+	wg_dbg("Entering: wg_mod_exit\n");
+
 	wg_genetlink_uninit();
+	wg_dbg("wg_mod_exit: wg_genetlink_uninit() completed\n");
+
 	wg_device_uninit();
+	wg_dbg("wg_mod_exit: wg_device_uninit() completed\n");
+
 	wg_peer_uninit();
+	wg_dbg("wg_mod_exit: wg_peer_uninit() completed\n");
+
 	wg_allowedips_slab_uninit();
+	wg_dbg("wg_mod_exit: wg_allowedips_slab_uninit() completed\n");
+
+	wg_dbg("Exiting: wg_mod_exit\n");
 }
 
 module_init(wg_mod_init);
 module_exit(wg_mod_exit);
 MODULE_LICENSE("GPL v2");
-MODULE_DESCRIPTION("WireGuard secure network tunnel");
+MODULE_DESCRIPTION("WireGuard secure network tunnel - with UDP/TCP");
 MODULE_AUTHOR("Jason A. Donenfeld <Jason@zx2c4.com>");
 MODULE_VERSION(WIREGUARD_VERSION);
 MODULE_ALIAS_RTNL_LINK(KBUILD_MODNAME);
